{ ------------------------------------------------------- }
{                        LESS.PAS                         }
{        Tool zum Anzeigen von beliebigen Dateien         }
{                                                         }
{             (C) 1990 by toolbox & M. Kmmerer           }
{ ------------------------------------------------------- }
PROGRAM Less;
{$D-,E-,L-,R-,S-}
Uses Crt,Dos;
Type Inhalt    = String;
     ListenPtr = ^Liste;
     InhaltPtr = ^Inhalt;
     Liste     = Record
                    Prev: ListenPtr;
                    This: InhaltPtr;
                    Next: ListenPtr;
                 end;
     Str80     = String[80];
     Chr80     = Array[1..80] of Char;
const Show   :Byte=1;   { Fr InfoZeile }
      Load   :Byte=2;
      FirstLn:Byte=3;
      LastLn :Byte=4;
      Auto   :Byte=5;
      Speed  :Byte=6;
      RowNr  :Byte=7;
      RowNrL :Byte=8;
      Off    =$2000;   { Fr SetCrsr }
      On     =$0607;
      Large  =$12;
      Short  =$11;
      MaxLines : Array[0..1] of Byte =( 24, 42);
      SpeedArray: Array [1..5] of Word=(400,200,100,50,20);
                                       { 1   2   3  4  5 }
Var  LPtr,                    { aktuelle Liste }
     First,                   { erste    Liste }
     Last    : ListenPtr;     { letzte   Liste }
     IPtr    : InhaltPtr;     { Line Zeiger    }
     FileName: String;        { Dateiname      }
     TestFile: File of Char;
     BinFile : File of Chr80;
     TxtFile : Text;
     EgaVga,
     Break,
     Closed,             { Datei geschlossen             }
     PtrUP,              { Listenzeiger auf 1. Bildzeile }
     AScroll,            { Automatisches Scrollen        }
     Binary,             { Binre Datei                  }
     Abbr,               { Benutzer-Abbruch              }
     Dump    : Boolean;  { Ausgabe als Dump              }
     Fa0, Fa1,
     DumpLn,      { Zhler fr Dumpzeilen in einer Zeile }
     LastDump,         { Dumpzeilen in der letzten Zeile }
     SpeedNr,           { Geschwindigkeit fr AutoScroll }
     YPos,
     Big,
     I       : Byte;
     Flags,                        { Datei Flags sichern }
     Element,
     ScrMode,
     Row,              { Aktuelle Zeile. genau bis 65535 }
     LastRow : Word;   { Anzahl der gelesenen Zeilen     }
     Regs    : Registers;
     Line    : String[80];

PROCEDURE Mono;                      { Monografikkarte ? }
     Begin
        Intr($11, Regs);
        If (Regs.AX and 48)=48 then begin
           ScrMode:=$b000;
           Fa0:=Magenta;                { Farbe fr Mono }
           Fa1:=Cyan;
           EgaVga:=False;
        end else begin
           ScrMode:=$b800;         { Farbe fr Farbkarte }
           Fa0:=Green;
           Fa1:=LightGreen;
           Regs.AH:=$12; Regs.BL:=$10;
           Intr($10, Regs);
           If (Regs.BL <> 16) and (Regs.BH = 0) then
              EgaVga:=TRUE
           else
              EgaVga:=FALSE;
        end;
     End;

PROCEDURE Print(Text: String);
     Begin
        TextColor(Fa1);  Write(Text); TextColor(Fa0);
     End;

PROCEDURE WriteCenter(Y: Byte; Text: String; Col: byte);
     Begin
        GotoXY(39-Round(Length(Text)/2), Y);
        TextColor(Col);  Write(#32+Text+#32);
     End;

PROCEDURE SetCrsr( Form : Word);    { Cursor an oder aus }
     Begin
        Regs.AH:=1; Regs.CX:=Form; Intr ($10,Regs);
     End;

PROCEDURE ClrKeyBuffer;         { Tastaturpuffer lschen }
     Begin
        Regs.AX:=$c00;  MsDos(Regs);
     End;

FUNCTION Min (One: Byte; Two: Word) : Byte;
     Begin
        If One<Two then  Min:=One
                   else  Min:=Two;
     End;

FUNCTION UpStr(Arg: String) : String;
     Var I  : Byte;    { String in Grobuchsaben wandeln }
         Help: String;
     Begin
        Help:='';
        For I:=1 to Length(Arg) do
           Help:=Help+UpCase(Arg[I]);
        UpStr:=Help;
     End;

PROCEDURE RechtEck (Dick: Boolean);
     Var I  : Byte;
         Top: String[80];
         Breit, Lang,
         X,     Y     : Byte;
         LW,  LS,
         ELO, ELU,
         ERO, ERU     : Char;
     Begin
        TextColor(Fa1);
        If Dick then begin
           Breit:=80; Lang:=2;  X:=1;      Y:=1;
           LW:='';   LS:='';
           ELO:='';  ERO:=''; ELU:='';   ERU:='';
        end else begin
           Breit:=77; Lang:=12; X:=2;      Y:=11;
           LW:='';   LS:='';
           ELO:='';  ERO:=''; ELU:='';  ERU:='';
        end;
        Top:='';
        For I:=1 to Breit do
           Top:=Top+LW;
        Top[1]:=ELO;    Top[Breit]:=ERO;
        GotoXY(X,Y); Write(Top);
        If not(Dick) then
           Line:=Top;
        For I:=1 to Lang do begin
           GotoXY(X,Y+I); Write(LS);
           GotoXY(Breit+X-1,Y+I); Write(LS);
        end;
        Top[1]:=ELU; Top[Breit]:=ERU;
        GotoXY(X,1+I+Y); Write(Top);
     End;

PROCEDURE Titel;                        { Titel ausgeben }
     Begin
        Window(1,1,25,80);
        ClrScr;
        RechtEck(TRUE);
        TextColor(Fa0);
        WriteCenter(2,'Less PC V2.4', Fa0);
        WriteCenter(3,'t  o  o  l  b  o  x', Fa1);
     End;

PROCEDURE InfoZeile(St: Byte);  { 1. Zeile aktualisieren }
     Const Status : Array[1..5] of String[14] =
                    ('Text anzeigen ',
                     'Text laden    ',
                     'Erste Zeile   ',
                     'Letzte Zeile  ',
                     'Auto scrolling');
     Begin
        Window(1,1,80,MaxLines[Big]+1);
        If (not(AScroll)) or (St<>Show) then begin
           If (St in [FirstLn, LastLn, Load]) then
              TextColor(Fa0)
           else
              TextColor(Fa1);
           Case St of
           1..5 : begin
                     GotoXY(37,1); Write(Status[St]);
                  end;
              6 : begin
                     GotoXY(59,1); Write(SpeedNr);
                  end;
              7 : begin
                     If PtrUp then begin
                        GotoXY(65,1); Write(Row+(Min(
                          MaxLines[Big],LastRow)-1):5);
                     end else begin
                        GotoXY(65,1); Write(Row:5);
                     end;
                  end;
              8 : begin
                     GotoXY(75,1); Write(LastRow);
                  end;
           end;
        end;
        Window(1,2,80,MaxLines[Big]+1);
     End;

PROCEDURE Info;                      { 1. Zeile aufbauen }
     Const Bin    : Array[0..1] of String[5] =
                     (' TEXT ','BINR');
     Begin
        Window(1,1,80,2);
        ClrScr;
        TextColor(Fa0);
        GotoXY(1,1);
        Write('               ',         {  15 Space }
              'Typ:         ',           {   9 Space }
              'Status:                ', {  16 Space }
              'Gschw.   ',               {   3 Space }
              'Zl.       v.      ');     { 7,6 Space }
        TextColor(Fa1);
        Repeat
           I:=Pos('\', FileName);
           If I=0 then I:=Pos('/', FileName);
           Delete( FileName, 1,I);
        Until (I=0);
        GotoXY( 1,1); Write(UpStr(FileName));
        GotoXY(22,1);
        If not(Dump) then
           Write(Bin[Ord(Binary)])
        else
           Write(' DUMP ');
        GotoXY(59,1); Write(SpeedNr);
        InfoZeile(Show);
     End;

FUNCTION Taste : Word;             { Liest Tasteneingabe }
     Var Ch  : Char;               { und bergibt den    }
         Help: Word;               { Zahlenwert.         }
     Begin                         { Sondertasten fangen }
        Help:=0; Ch:=ReadKey;      { fangen bei 1000 an  }
        If ch=#0 then begin
           Ch:=ReadKey;
           Inc(Help,1000);
        end;
        Inc(Help, Ord(Ch));
        Taste:=Help;
     End;

FUNCTION Proov(Text:String; Start, Lgth: Byte) : String;
     Var Help: String;         { Ersetzt nicht druckbare }
         I,                    { Zeichen duch Punkte     }
         Cnt : Byte;
     Begin
        Help:=Copy(Text, Start, Lgth);
        Cnt:=Byte(Help[0]);
        For I:=1 to Cnt do
           If (Help[I]<#32) then
              Help[I]:=#46; {'.'}
        Proov:=Help;
     End;

PROCEDURE GetLine;      { Liest eine Zeile aus der Datei }
     Var I,
         A      : Byte;
         Line   : Str80;
         Len    : Byte absolute Line;
         BinBuff: Chr80;
         Fehler,
         GoOn   : Boolean;
         Help   : String;

     PROCEDURE AddList;   { Fgt die Zeile einer doppelt }
          Begin           { verketteten Liste an         }
             New(LPtr);
             GetMem(IPtr, Length(Line)+1);
             IPtr^:=Line;
             LPtr^.Prev:=Last;
             LPtr^.This:=IPtr;
             LPtr^.Next:=Nil;
             If First=Nil then
                First:=LPtr;
             If Last<>Nil then
                Last^.Next:=LPtr;
             Last:=LPtr;

             LastDump:=Trunc(Len/16)+Ord(Len mod 16<>0);
            { Letzte eingelesene Zeile =
                                    wieviele Dumpzeilen  }
             If Dump then begin
                Inc(Row,    LastDump);
                Inc(LastRow,LastDump);
             end else begin
                Inc(Row);
                Inc(LastRow);
             end;
          End;

     Begin
        Line:=''; GoOn:=False;
        For I:=1 to 80 do BinBuff[I]:=#26;
        {$I-}
           If (Binary) or (Dump) then begin
              Read(BinFile, BinBuff); { Bei Binr        }
              Fehler:=(IOResult<>0);
              I:=0;                   { 80 Zeichen lesen }
              Repeat
                 Inc(I);
                 Line[I]:=BinBuff[I];
              Until (I=80) or
                    ((BinBuff[I]=#26) and
                     ((Fehler) or
                      (Eof(BinFile)) ) );
              Line[0]:=Chr(I);
              If (Fehler) or (Eof(BinFile)) then begin
                 GoOn:=True;
                 Line[0]:=Chr(Ord(Line[0])-1);
              end;

           end else begin                  { Bei Text    }
              ReadLn(TxtFile, Line);       { Zeile lesen }
              If (IOResult<>0) or (Eof(TxtFile)) then
                 GoOn:=True;
              If Line='' then           { Bei Leerzeilen }
                 Line:=#32;   { Zeile mit Space erzeugen }
           end;
        {$I+}
        If (KeyPressed) and (Taste=27) then begin
           GoON:=True;
           Abbr:=TRUE;
        end;

        If (GoOn) then begin { Lesefehler                }
           Closed:=True;
           If (Len>0) then
              AddList;
           If Binary then begin
              Close(BinFile);
              SetFAttr(BinFile, Flags);
           end else begin
              Close(TxtFile);
              SetFAttr(TxtFile, Flags);
           end;
           Exit;
        end;
        AddList;
     End;

PROCEDURE SetUp(Times: Byte); FORWARD;

PROCEDURE GetAll;               { gesamte Datei einlesen }
     Begin
        InfoZeile(Load);
        Repeat
           GetLine;
        Until (Closed);
        InfoZeile(RowNrL);
     End;

PROCEDURE IncPtr;    { Listenzeiger auf nchstes Element }
     Begin
        Break:=False;
        If not(Dump) then
           LPtr:=LPtr^.Next
        else begin
           Inc(DumpLn);
           if ((LPtr^.Next=Nil) and (DumpLn>LastDump)) then
              LPtr:=Nil
           else
              If DumpLn>5 then begin
                 DumpLn:=1;
                 LPtr:=LPtr^.Next;
              end;
        end;
        If LPtr=Nil then begin
           LPtr:=Last; Row:=LastRow; DumpLn:=LastDump;
           Break:=TRUE;
        end else begin
           Inc(Row); Inc(YPos);
        end;
     End;

PROCEDURE DecPtr;  { Listenzeiger auf vorheriges Element }
     Begin
        Break:=False;
        If not(Dump) then
           LPtr:=LPtr^.Prev
        else begin
           Dec(DumpLn);
           If DumpLn<1 then begin
              DumpLn:=5;
              LPtr:=LPtr^.Prev;
           end;
        end;
        If LPtr=Nil then begin
           LPtr:=First; Row:=1; DumpLn:=1;
           Break:=TRUE;
        end else begin
           Dec(Row); Dec(YPos);
        end;
     End;

PROCEDURE PrintLine; { Zeile auf dem Bildschirm ausgeben }
     Var I,
         J,
         Len,
         Start : Byte;
         Help,
         Line  : String;
         HelpNr: Byte;

     PROCEDURE PrintHexByte(Value: Byte);   { Hexausgabe }
          Var Digit,
              I      : Byte;
          Begin
             For I:=1 downto 0 do begin
                Digit:=((Value Shr (I*4)) and $F);
                If Digit<10 then
                   Line:=Line+(Char(Digit+48))
                else
                   Line:=Line+(Char(Digit+55));
             end;
             Line:=Line+#32;
          End;

     PROCEDURE PrintHexWord(Zahl: Word);   { Hexausgabe }
          Var Digit,
              I      : Byte;
              Value  : Word;
          Begin
             Value:=Zahl*16-16;
             Line:=Line+'$';
             For I:=3 downto 0 do begin
                Digit:=((Value Shr (I*4)) and $F);
                If Digit<10 then
                   Line:=Line+(Char(Digit+48))
                else
                   Line:=Line+(Char(Digit+55));
             end;
             Line:=Line+(#32#32#32);
          End;

     PROCEDURE PrintLast;
          Const Offset: Array[0..2] of Word =
                        (318, 3998, 6878);
          Var Adr: Byte;
          Begin
             If YPos=1 then
                Adr:=0
             else
                Adr:=Big+1;
             Write(Copy(Line, 1,79));
             Mem[ScrMode:Offset[Adr]]:=Ord(Line[80]);
             Mem[ScrMode:Offset[Adr]+1]:=Fa1;
          End;

     Begin
        Line:='';
        InfoZeile(Show);
        Len:=Length(LPtr^.This^);
        TextColor(Fa1);
        If not(Dump) then
            Line:=Proov(LPtr^.This^,1,80)
        else begin
           I:=0;                           { Hex Ausgabe }
           Len:=Length(LPtr^.This^)-((DumpLn-1)*16);
           Start:=((DumpLn-1)*16)+1;
           PrintHexWord(Row);         { Hex Zeilennummer }
           Repeat
              Help:=Copy(LPtr^.This^,Start+I,1);
              HelpNr:=Ord(Help[1]);
              PrintHexByte(HelpNr);        { Hex Zeichen }
              Inc(I);
           Until (I=16) or (I=Len);
           For J:=1 to 17-I do
              Line:=Line+(#32#32#32);
           I:=0;
           Repeat
              Help:=Proov(LPtr^.This^,Start+I,1);
              Line:=Line+Help;           { ASCII Zeichen }
              Inc(i);
           Until (I=16) or (I=Len);
        end;

        If YPos=0 then begin
           GotoXY(1,1);
           InsLine;
           Inc(YPos);
        end else
           If YPos>MaxLines[Big] then begin
              GotoXY(80,MaxLines[Big]);
              WriteLn;
              Dec(YPos);
           end else
              GotoXY(1,YPos);
           If (YPos in [1, MaxLines[Big]]) and
               (Line[0]=#80) then
              PrintLast
           else begin
              Write(Line);
              ClrEol;
           end;
     End;

PROCEDURE ShowPage;               { ganze Seite ausgeben }
     Var Ln  : Byte;
         GoOn: Boolean;
     Begin
        Ln:=0; GoOn:=False; Break:=False;
        InfoZeile(Show);
        Repeat
           If Ln=MaxLines[Big] then
              GoOn:=True
           else begin
              If Ln<>0 then
                 IncPtr;
              Inc(Ln);
              If Not(Break) then
                 PrintLine;
           end;
        Until (GoOn or Break);
        PtrUP:=False;
     End;

PROCEDURE SetDown(Times: Byte);
     Var I: Byte;
     Begin
        If PtrUp then begin
           I:=0;
           Repeat
              IncPtr;
              Inc(I);
           Until (I=Times) or (Break);
           PtrUP:=False;
        end;
        YPos:=Min(MaxLines[Big], LastRow);
     End;

PROCEDURE SetUp(Times: Byte);
     Var I: Byte;
     Begin
        If not(PtrUp) then begin
           I:=0;
           Repeat
              DecPtr;
              Inc(I);
           Until (I=Times) or (Break);
           PtrUp:=True;
        end;
        YPos:=1;
     End;

PROCEDURE Down;         { Eine Zeile nach unten scrollen }
     Begin
        SetDown(MaxLines[Big]-1);
        IncPtr;
        If not (Break) then begin
           InfoZeile(Show);
           PrintLine;
        end else
         InfoZeile(LastLn);
     End;

PROCEDURE Up;            { Eine Zeile nach oben scrollen }
     Begin
        SetUp(MaxLines[Big]-1);
        DecPtr;
        If not (Break) then begin
           InfoZeile(Show);
           PrintLine;
        end else
           InfoZeile(FirstLn);
  End;

PROCEDURE Home;                   { erste Seite ausgeben }
     Begin
        LPtr:=First; Row:=1; DumpLn:=1; YPos:=1;
        ShowPage;
     End;

PROCEDURE Foot;                  { letzte Seite ausgeben }
     Begin
        LPtr:=Last; Row:=LastRow;
        DumpLn:=LastDump; PtrUp:=False;
        SetUp(MaxLines[Big]-1);
        ShowPage;
     End;

PROCEDURE PageDown;     { eine Seite nach unten scrollen }
     Begin
        SetDown(MaxLines[Big]-1);
        If not(Break) then begin
           PtrUp:=True;
           SetDown(MaxLines[Big]);
           SetUp(MaxLines[Big]-1);
           ShowPage;
        end else
           InfoZeile(LastLn);
     End;

PROCEDURE PageUp;        { eine Seite nach oben scrollen }
     Begin
        SetUp(MaxLines[Big]-1);
        If not(Break) then begin
           PtrUp:=False;
           SetUp(MaxLines[Big]);
           ShowPage;
        end else
           InfoZeile(FirstLn);
     End;

PROCEDURE TestBinary;       { Datei auf Binrfile testen }
     Var Test: Char;
         I   : Byte;
     Begin
        If not(Dump) then begin { Bei Dump nicht ntig.. }
           Binary:=False; I:=1;
           Repeat
              Read(TestFile, Test);
              If (Test<#32) and
                  not(Test in [#09..#13]) then
                 Binary:=True;
              Inc(I);
           Until (I=80) or (Binary);
        end else
           Binary:=True;               { ..da immer True }
        Close(TestFile);
        If Binary then begin
           Assign (BinFile, Filename);
           Reset(BinFile);
        end else begin
           Assign (TxtFile, Filename);
           Reset(TxtFile);
        end;
     End;

PROCEDURE OpenFile;           { Versucht Datei zu ffnen }
     Begin
        Assign (TestFile, FileName);
        GetFAttr(TestFile, Flags);
        SetFAttr(TestFile, 0);
        {$I-} Reset(TestFile); {$I+}
        If IOResult<>0 then begin
           Closed:=True;
           GotoXY(1,10);
           Print(#7+'Kann Datei nicht ffnen: ');
           Write(FileName);
           Delay(1000);
        end else
           Closed:=False;
     End;

PROCEDURE Help;
     Begin
        Titel;
        GotoXY(1,8);
        WriteLN('Aufruf:        LESS [Dateiname]'#10#13);
        WriteLn('Tasten:');
        WriteLn('  '#24'/'#25'        : '+
                'Zeile hoch/runter scrollen');
        WriteLn('  Bild'#24'/Bild'#25': '+
                'Eine Seite hoch/runter');
        WriteLn('  Pos1       : '+
                'Erste Seite');
        WriteLn('  Ende       : '+
                'Letzte Seite'#10#13);
        WriteLn('  Leertaste  : '+
                'Autoscrolling an/aus');
        WriteLn('  +/-        : '+
                'Geschwindigkeit'#10#13);
        WriteLn('  Einfg, H   : '+
                'Toggle Normal/Hex (Binr)');
        WriteLn('  F1         : '+
                'Bildschirmformat (EGA/VGA)'#10#13);
        WriteLN('  Entf, L    : Neue Datei laden');

        Halt;
     End;

PROCEDURE ClearRam;               { Liste wieder lschen }
     Var Ptr: ListenPtr;
     Begin
        LPtr:=Last;
        While not(LPtr=Nil) do begin
           FreeMem(LPtr^.This, Length(LPtr^.This^)+1);
           Ptr:=LPtr;
           LPtr:=LPtr^.Prev;
           Dispose(Ptr);
        end;
     End;

PROCEDURE Quit( DOS: Boolean);
                       { Alles fertigmachen zum Ausstieg }
     Begin
        If Big<>0 then
           TextMode(LastMode-Font8x8);
        Window(1,1, 80,25);
        ClearRam;
        If not(Closed) then
           If Binary then begin
              Close(BinFile);
              SetFAttr(BinFile, Flags);
           end else begin
              Close(TxtFile);
              SetFAttr(TxtFile, Flags);
           end;
        If Dos then begin
           Titel;
           GotoXY(1,7);
           WriteLn('Zurck zu DOS.'#10#13);
           CheckBreak:=True;
           Halt;
        end;
           SetCrsr(On);
     End;


PROCEDURE InputFileName;
                      { Dateiname und Parameter eingeben }
     Var Answer: String[1];
         I     : Byte;

     Begin
        GetDir(0, FileName);
        GotoXY(1,7); Print('Aktueller Pfad : ');
        Write(FileName);

        FileName:='';
        GotoXY(1,10); ClrEol;
        Print('Dateiname : '); ReadLN(FileName);
        If FileName='' Then
           Quit(TRUE);
     End;

Label Error, Again;
Var PC: Word;
BEGIN
   PC:=ParamCount;
Again:
   First:=Nil;   Last:=Nil;         AScroll:=False;
   Dump:=False;  Abbr:=False;       Big:=0;
   SpeedNr:=3;   LastRow:=0;        Row:=0;
   PtrUp:=False; CheckBreak:=False; 
   TextBackGround(Black);
   Mono;
   Titel;
   GotoXY(1,10);
   If PC=0 then
      InputFilename
   else begin
      If PC=1 then begin
         If ParamStr(1)='?' then
            Help
         else
            FileName:=ParamStr(1);
      end else
         Goto Error
   end;
   Repeat
      OpenFile;
      If Closed then InputFileName;
   Until not(Closed);
   TestBinary;
   If EgaVga then begin
      TextMode(Lo(LastMode)+Font8x8);
      Big:=1;
   end else
      Big:=0;
   CheckSnow:=FALSE;
   TextBackGround(Black); ClrScr;
   SetCrsr(Off);
   Info;
   GetAll;
   If Abbr then begin
      Quit(FALSE);
      PC:=0;
      Goto Again;
   end;
   YPos:=1;
   Window(1,2,80,MaxLines[Big]+1);
   Home;
   Repeat
      InfoZeile(RowNr);
        Case Taste of
        1059 : If EgaVga  then begin
                  If not(PtrUp) then
                     SetUp(MaxLines[Big]-1);
                  If Big = 0 then begin
                     TextMode(Lo(LastMode)+Font8x8);
                     Big:=1;
                  end else begin
                     TextMode(LastMode-Font8x8);
                     Big:=0;
                  end;
                  SetCrsr(OFF);
                  Info;
                  InfoZeile(8);
                  ShowPage;
               end;
        1072 : Up;
        1080 : Down;
        1073 : PageUp;
        1081 : PageDown;
        1071 : Home;
        1079 : Foot;
        104,
        1082 : If Binary then begin
                  SetUp(MaxLines[Big]-1);
                  Dump:=Not(Dump);
                  If Dump then
                    LastRow:=(LastRow-1)*5+LastDump
                  else
                    LastRow:=Round((LastRow-LastDump)/5)+1;
                  If LastRow<1 then
                    LastRow:=1;
                  Info;         InfoZeile(RowNrL);
                  ClrScr;       ShowPage;
               end;
          32 : begin
                  AScroll:=not(AScroll);
                  If not(AScroll) then
                     InfoZeile(Show);
               end;
          27 : Quit(TRUE);
        108,
        1083 : begin
                  Quit(False);
                  PC:=0;
                  Goto Again;
               end;
          45 : If SpeedNr>1 then begin
                  Dec(SpeedNr);
                  InfoZeile(Speed);
               end;
          43 : If SpeedNr<5 then begin
                  Inc(SpeedNr);
                  InfoZeile(Speed);
               end;
      end;
     Repeat
      If AScroll then begin     { Automatisches Scrollen }
         InfoZeile(Auto);
         Down;
         Delay(SpeedArray[SpeedNr]);
         InfoZeile(RowNr);
         If (Break) and (Closed) then
            AScroll:=False
      end;
     Until (KeyPressed) or (not(AScroll));
   Until (FALSE);

Error:
   TextColor(Fa0);
   GotoXY(1,7);
   WriteLn('Aufruf: Less [Dateiname] oder Less ? '+
           'fr Hilfe');
END.