 (* ------------------------------------------------------ *)
 (*                     DRUCKER.PAS                        *)
 (*    erweitert und ersetzt die Standard-Unit PRINTER     *)
 (*          (c) 1990 Jrgen Plehn & TOOLBOX               *)
 (* ------------------------------------------------------ *)
 UNIT Drucker;
 
 INTERFACE  (* ------------------------------------------- *)
 
 USES Dos, Printer;
 
 VAR
   lst : TEXT ABSOLUTE printer.lst;
 
   FUNCTION Prn_Ready : BOOLEAN;
 
 IMPLEMENTATION (* --------------------------------------- *)
 
   FUNCTION Prn_Ready : BOOLEAN;
   { gibt TRUE zurck, falls der Drucker bereit ist         }
   VAR
     Regs : Registers;
   BEGIN
     WITH Regs DO BEGIN
       ah := 2;
       dx := 0; { LPT1 }
       Intr($17, Regs);
       ah := ah AND $39;
       IF ah <> $10 THEN Prn_Ready := FALSE
                    ELSE Prn_Ready := TRUE;
     END;
   END {Prn_Ready};
 
 BEGIN
 END {Drucker}.
 (* ------------------------------------------------------ *)
 (*                 Ende von DRUCKER.PAS                   *)
